--- /dev/null	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/strncasecmp.c	Tue May 20 07:58:51 2014
@@ -0,0 +1,75 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ */
+
+/*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+/*
+ * Portions of this source code were derived from Berkeley 4.3 BSD
+ * under license from the Regents of the University of California.
+ */
+
+#include "lint.h"
+#include <sys/types.h>
+#include <strings.h>
+#include <ctype.h>
+#include <locale.h>
+#include "lctype.h"
+#include "localeimpl.h"
+
+int
+strncasecmp_l(const char *s1, const char *s2, size_t n, locale_t loc)
+{
+	extern int ascii_strncasecmp(const char *s1, const char *s2, size_t n);
+	const int *cm;
+	const uchar_t *us1;
+	const uchar_t *us2;
+	const struct lc_ctype *lct = loc->ctype;
+
+	/*
+	 * If we are in a locale that uses the ASCII character set
+	 * (C or POSIX), use the fast ascii_strncasecmp() function.
+	 */
+	if (lct->lc_is_ascii)
+		return (ascii_strncasecmp(s1, s2, n));
+
+	cm = lct->lc_trans_lower;
+	us1 = (const uchar_t *)s1;
+	us2 = (const uchar_t *)s2;
+
+	while (n != 0 && cm[*us1] == cm[*us2++]) {
+		if (*us1++ == '\0')
+			return (0);
+		n--;
+	}
+	return (n == 0 ? 0 : cm[*us1] - cm[*(us2 - 1)]);
+}
+
+int
+strncasecmp(const char *s1, const char *s2, size_t n)
+{
+	return (strncasecmp_l(s1, s2, n, uselocale(NULL)));
+}
--- old/usr/src/lib/libc/port/locale/strptime.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/strptime.c	Tue May 20 07:58:51 2014
@@ -1,5 +1,6 @@
 /*
  * Copyright (c) 2014 Gary Mills
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2011, Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1994 Powerdog Industries.  All rights reserved.
  *
@@ -40,31 +41,30 @@
 #include <string.h>
 #include <pthread.h>
 #include <alloca.h>
+#include <locale.h>
 #include "timelocal.h"
+#include "localeimpl.h"
 
 #define	asizeof(a)	(sizeof (a) / sizeof ((a)[0]))
 
 #define	F_GMT		(1 << 0)
-#define	F_ZERO		(1 << 1)
 #define	F_RECURSE	(1 << 2)
 
 static char *
-__strptime(const char *buf, const char *fmt, struct tm *tm, int *flagsp)
+__strptime(const char *_RESTRICT_KYWD buf, const char *_RESTRICT_KYWD fmt,
+    struct tm *_RESTRICT_KYWD tm, int *_RESTRICT_KYWD flagsp,
+    locale_t _RESTRICT_KYWD loc)
 {
 	char	c;
 	const char *ptr;
 	int	i, len, recurse = 0;
 	int Ealternative, Oalternative;
-	struct lc_time_T *tptr = __get_current_time_locale();
+	const struct lc_time *tptr = loc->time;
 
 	if (*flagsp & F_RECURSE)
 		recurse = 1;
 	*flagsp |= F_RECURSE;
 
-	if (*flagsp & F_ZERO)
-		(void) memset(tm, 0, sizeof (*tm));
-	*flagsp &= ~F_ZERO;
-
 	ptr = fmt;
 	while (*ptr != 0) {
 		if (*buf == 0)
@@ -93,7 +93,7 @@
 			break;
 
 		case '+':
-			buf = __strptime(buf, tptr->date_fmt, tm, flagsp);
+			buf = __strptime(buf, tptr->date_fmt, tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
@@ -116,13 +116,13 @@
 			break;
 
 		case 'c':
-			buf = __strptime(buf, tptr->c_fmt, tm, flagsp);
+			buf = __strptime(buf, tptr->c_fmt, tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
 
 		case 'D':
-			buf = __strptime(buf, "%m/%d/%y", tm, flagsp);
+			buf = __strptime(buf, "%m/%d/%y", tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
@@ -140,37 +140,37 @@
 			goto label;
 
 		case 'F':
-			buf = __strptime(buf, "%Y-%m-%d", tm, flagsp);
+			buf = __strptime(buf, "%Y-%m-%d", tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
 
 		case 'R':
-			buf = __strptime(buf, "%H:%M", tm, flagsp);
+			buf = __strptime(buf, "%H:%M", tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
 
 		case 'r':
-			buf = __strptime(buf, tptr->ampm_fmt, tm, flagsp);
+			buf = __strptime(buf, tptr->ampm_fmt, tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
 
 		case 'T':
-			buf = __strptime(buf, "%H:%M:%S", tm, flagsp);
+			buf = __strptime(buf, "%H:%M:%S", tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
 
 		case 'X':
-			buf = __strptime(buf, tptr->X_fmt, tm, flagsp);
+			buf = __strptime(buf, tptr->X_fmt, tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
 
 		case 'x':
-			buf = __strptime(buf, tptr->x_fmt, tm, flagsp);
+			buf = __strptime(buf, tptr->x_fmt, tm, flagsp, loc);
 			if (buf == NULL)
 				return (NULL);
 			break;
@@ -519,11 +519,14 @@
 }
 
 char *
-strptime(const char *buf, const char *fmt, struct tm *tm)
+strptime(const char *_RESTRICT_KYWD buf, const char *_RESTRICT_KYWD fmt,
+    struct tm *_RESTRICT_KYWD tm)
 {
-	int	flags = F_ZERO;
+	int	flags = 0;
 
-	return (__strptime(buf, fmt, tm, &flags));
+	(void) memset(tm, 0, sizeof (*tm));
+
+	return (__strptime(buf, fmt, tm, &flags, uselocale(NULL)));
 }
 
 /*
@@ -531,9 +534,31 @@
  * incoming tm.  It is triggered by -D_STRPTIME_DONTZERO.
  */
 char *
-__strptime_dontzero(const char *buf, const char *fmt, struct tm *tm)
+__strptime_dontzero(const char *_RESTRICT_KYWD buf,
+    const char *_RESTRICT_KYWD fmt, struct tm *_RESTRICT_KYWD tm)
 {
 	int	flags = 0;
 
-	return (__strptime(buf, fmt, tm, &flags));
+	return (__strptime(buf, fmt, tm, &flags, uselocale(NULL)));
+}
+
+/*
+ * strptime_l is an extension that seems natural, and indeed, MacOS X
+ * includes it within their <xlocale.h> and it is part of GNU libc as well.
+ * For now we restrict it to the cases where strict namespaces are not
+ * included.  We expect to see it in a future version of POSIX.  locale_t is
+ * not a restrict, since the spec for it doesn't assume its a pointer.  We
+ * therefore pass it analagously to the way strftime_l is specified.
+ *
+ * We are not providing a non-zeroing version at this time.
+ */
+char *
+strptime_l(const char *_RESTRICT_KYWD buf, const char *_RESTRICT_KYWD fmt,
+    struct tm *_RESTRICT_KYWD tm, locale_t loc)
+{
+	int	flags =  0;
+
+	(void) memset(tm, 0, sizeof (*tm));
+
+	return (__strptime(buf, fmt, tm, &flags, loc));
 }
--- old/usr/src/lib/libc/port/locale/strxfrm.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/strxfrm.c	Tue May 20 07:58:51 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1995 Alex Tatmanjants <alex@elvisti.kiev.ua>
  *		at Electronni Visti IA, Kiev, Ukraine.
@@ -32,10 +33,12 @@
 #include <errno.h>
 #include <wchar.h>
 #include <assert.h>
+#include <xlocale.h>
 #include "collate.h"
 
 size_t
-strxfrm(char *_RESTRICT_KYWD xf, const char *_RESTRICT_KYWD src, size_t dlen)
+strxfrm_l(char *_RESTRICT_KYWD xf, const char *_RESTRICT_KYWD src,
+    size_t dlen, locale_t loc)
 {
 	size_t slen;
 	size_t xlen;
@@ -54,16 +57,16 @@
 	 */
 	slen = strlen(src);
 
-	if (_collate_load_error)
+	if (loc->collate->lc_is_posix)
 		goto error;
 
 	if ((wcs = malloc((slen + 1) * sizeof (wchar_t))) == NULL)
 		goto error;
 
-	if (mbstowcs(wcs, src, slen + 1) == (size_t)-1)
+	if (mbstowcs_l(wcs, src, slen + 1, loc) == (size_t)-1)
 		goto error;
 
-	if ((xlen = _collate_sxfrm(wcs, xf, dlen)) == (size_t)-1)
+	if ((xlen = _collate_sxfrm(wcs, xf, dlen, loc)) == (size_t)-1)
 		goto error;
 
 	if (wcs)
@@ -84,4 +87,10 @@
 	(void) strlcpy(xf, src, dlen);
 
 	return (slen);
+}
+
+size_t
+strxfrm(char *_RESTRICT_KYWD xf, const char *_RESTRICT_KYWD src, size_t dlen)
+{
+	return (strxfrm_l(xf, src, dlen, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/table.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/table.c	Tue May 20 07:58:51 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -260,16 +261,8 @@
 	/* END CSTYLED */
 };
 
-_RuneLocale *_CurrentRuneLocale = &_DefaultRuneLocale;
-
 /* Taken from former _ctype.c */
 unsigned int *__ctype_mask = _DefaultRuneLocale.__runetype;
 
 int *__trans_lower = _DefaultRuneLocale.__maplower;
 int *__trans_upper = _DefaultRuneLocale.__mapupper;
-
-/*
- * Used in various string routines to conditionalize versions optimized for
- * the ASCII case
- */
-int charset_is_ascii = 1;
--- old/usr/src/lib/libc/port/locale/timelocal.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/timelocal.c	Tue May 20 07:58:51 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * Copyright (c) 1997 FreeBSD Inc.
@@ -28,16 +29,14 @@
 
 #include "lint.h"
 #include <stddef.h>
+#include <errno.h>
 #include "ldpart.h"
 #include "timelocal.h"
+#include "localeimpl.h"
 
-static struct lc_time_T _time_locale;
-static int _time_using_locale;
-static char *time_locale_buf;
+#define	LCTIME_SIZE (sizeof (struct lc_time) / sizeof (char *))
 
-#define	LCTIME_SIZE (sizeof (struct lc_time_T) / sizeof (char *))
-
-static const struct lc_time_T	_C_time_locale = {
+struct lc_time lc_time_posix = {
 	{
 		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
 		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
@@ -84,17 +83,33 @@
 	"%I:%M:%S %p"
 };
 
-struct lc_time_T *
-__get_current_time_locale(void)
-{
-	return (_time_using_locale ? &_time_locale :
-	    (struct lc_time_T *)&_C_time_locale);
-}
+struct locdata __posix_time_locdata = {
+	.l_lname = "C",
+	.l_refcnt = (uint32_t)-1,
+	.l_data = { &lc_time_posix }
+};
 
-int
-__time_load_locale(const char *name)
+struct locdata *
+__lc_time_load(const char *name)
 {
-	return (__part_load_locale(name, &_time_using_locale,
-	    &time_locale_buf, "LC_TIME", LCTIME_SIZE, LCTIME_SIZE,
-	    (const char **)&_time_locale));
+	struct locdata	*ldata;
+	struct lc_time	*ltime;
+	int ret;
+
+	if ((ldata = __locdata_alloc(name, sizeof (*ltime))) == NULL) {
+		errno = EINVAL;
+		return (NULL);
+	}
+	ltime = ldata->l_data[0];
+
+	ret = __part_load_locale(name, (char **)&ldata->l_data[1],
+	    "LC_TIME", LCTIME_SIZE, LCTIME_SIZE, (const char **)ltime);
+
+	if (ret != _LDP_LOADED) {
+		__locdata_release(ldata);
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	return (ldata);
 }
--- old/usr/src/lib/libc/port/locale/timelocal.h	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/timelocal.h	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1997-2002 FreeBSD Project.
  * All rights reserved.
@@ -32,7 +33,7 @@
  * Private header file for the strftime and strptime localization
  * stuff.
  */
-struct lc_time_T {
+struct lc_time {
 	const char	*mon[12];
 	const char	*month[12];
 	const char	*wday[7];
@@ -46,7 +47,7 @@
 	const char	*ampm_fmt;
 };
 
-struct lc_time_T *__get_current_time_locale(void);
+struct lc_time *__get_current_time_locale(void);
 int	__time_load_locale(const char *);
 
 #endif /* !_TIMELOCAL_H_ */
--- old/usr/src/lib/libc/port/locale/tolower.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/tolower.c	Tue May 20 07:58:52 2014
@@ -10,22 +10,40 @@
  */
 
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  */
 #include "lint.h"
 #include <ctype.h>
+#include <locale.h>
+#include "localeimpl.h"
+#include "lctype.h"
 
 #pragma weak _tolower = tolower
 #pragma weak _toupper = toupper
 
 int
+tolower_l(int c, locale_t loc)
+{
+	return (((unsigned)c > 255) ? c : loc->ctype->lc_trans_lower[c]);
+}
+
+int
+toupper_l(int c, locale_t loc)
+{
+	return (((unsigned)c > 255) ? c : loc->ctype->lc_trans_upper[c]);
+}
+
+#undef tolower
+int
 tolower(int c)
 {
-	return (((unsigned)c > 255) ? c : __trans_lower[c]);
+	return (isascii(c) ? __trans_lower[c] : tolower_l(c, uselocale(NULL)));
 }
 
+#undef toupper
 int
 toupper(int c)
 {
-	return (((unsigned)c > 255) ? c : __trans_upper[c]);
+	return (isascii(c) ? __trans_upper[c] : toupper_l(c, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/towlower.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/towlower.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -39,21 +40,23 @@
 #include "lint.h"
 #include <wctype.h>
 #include <stdio.h>
+#include "localeimpl.h"
+#include "lctype.h"
 #include "runetype.h"
 
 static wint_t
-__change_case_ext(wint_t c, int lower)
+change_case_ext(locale_t loc, wint_t c, int lower)
 {
+	const _RuneLocale *rl;
+	const _RuneRange *rr;
+	const _RuneEntry *base, *re;
 	size_t lim;
-	_RuneRange *rr;
-	_RuneEntry *base, *re;
 
 	if (c < 0 || c == EOF)
 		return (c);
 
-	rr = lower ?
-	    &_CurrentRuneLocale->__maplower_ext :
-	    &_CurrentRuneLocale->__mapupper_ext;
+	rl = loc->runelocale;
+	rr = lower ? &rl->__maplower_ext : &rl->__mapupper_ext;
 	/* Binary search -- see bsearch.c for explanation. */
 	base = rr->__ranges;
 	for (lim = rr->__nranges; lim != 0; lim >>= 1) {
@@ -69,20 +72,40 @@
 	return (c);
 }
 
+wint_t
+towlower_l(wint_t wc, locale_t loc)
+{
+	return (iswascii(wc) ? __trans_lower[wc] :
+	    (wc < 0 || wc >= _CACHED_RUNES) ?
+	    change_case_ext(loc, wc, 1) :
+	    loc->runelocale->__maplower[wc]);
+}
+
 #undef towlower
 wint_t
 towlower(wint_t wc)
 {
-	return ((wc < 0 || wc >= _CACHED_RUNES) ?
-	    __change_case_ext(wc, 1) :
-	    _CurrentRuneLocale->__maplower[wc]);
+	return (iswascii(wc) ? __trans_lower[wc] :
+	    (wc < 0 || wc >= _CACHED_RUNES) ?
+	    change_case_ext(uselocale(NULL), wc, 1) :
+	    uselocale(NULL)->runelocale->__maplower[wc]);
 }
 
+wint_t
+towupper_l(wint_t wc, locale_t loc)
+{
+	return (iswascii(wc) ? __trans_upper[wc] :
+	    (wc < 0 || wc >= _CACHED_RUNES) ?
+	    change_case_ext(loc, wc, 0) :
+	    loc->runelocale->__mapupper[wc]);
+}
+
 #undef towupper
 wint_t
 towupper(wint_t wc)
 {
-	return ((wc < 0 || wc >= _CACHED_RUNES) ?
-	    __change_case_ext(wc, 0) :
-	    _CurrentRuneLocale->__mapupper[wc]);
+	return (iswascii(wc) ? __trans_upper[wc] :
+	    (wc < 0 || wc >= _CACHED_RUNES) ?
+	    change_case_ext(uselocale(NULL), wc, 0) :
+	    uselocale(NULL)->runelocale->__mapupper[wc]);
 }
--- old/usr/src/lib/libc/port/locale/utf8.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/utf8.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins
  * All rights reserved.
@@ -28,11 +29,11 @@
 #include "lint.h"
 #include <errno.h>
 #include <limits.h>
-#include "runetype.h"
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_UTF8_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
@@ -53,29 +54,16 @@
 	wchar_t	lbound;
 } _UTF8State;
 
-int
-_UTF8_init(_RuneLocale *rl)
+void
+_UTF8_init(struct lc_ctype *lct)
 {
-	__mbrtowc = _UTF8_mbrtowc;
-	__wcrtomb = _UTF8_wcrtomb;
-	__mbsinit = _UTF8_mbsinit;
-	__mbsnrtowcs = _UTF8_mbsnrtowcs;
-	__wcsnrtombs = _UTF8_wcsnrtombs;
-	_CurrentRuneLocale = rl;
-
-	charset_is_ascii = 0;
-
-	/*
-	 * In theory up to 6 bytes can be used for the encoding,
-	 * but only encodings with more than 4 bytes are illegal.
-	 */
-	__ctype[520] = 4;
-	/*
-	 * Note that the other CSWIDTH members are nonsensical for this
-	 * this coding.  They only are valid with EUC codings.
-	 */
-
-	return (0);
+	lct->lc_mbrtowc = _UTF8_mbrtowc;
+	lct->lc_wcrtomb = _UTF8_wcrtomb;
+	lct->lc_mbsinit = _UTF8_mbsinit;
+	lct->lc_mbsnrtowcs = _UTF8_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _UTF8_wcsnrtombs;
+	lct->lc_is_ascii = 0;
+	lct->lc_max_mblen = 4;
 }
 
 static int
--- old/usr/src/lib/libc/port/locale/wcrtomb.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/wcrtomb.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -27,14 +28,25 @@
 
 #include "lint.h"
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
+#include "localeimpl.h"
+#include "lctype.h"
 #include "mblocal.h"
 
 size_t
-wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc, mbstate_t *_RESTRICT_KYWD ps)
+wcrtomb_l(char *_RESTRICT_KYWD s, wchar_t wc, mbstate_t *_RESTRICT_KYWD ps,
+    locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__wcrtomb(s, wc, ps));
+	return (loc->ctype->lc_wcrtomb(s, wc, ps));
+}
+
+size_t
+wcrtomb(char *_RESTRICT_KYWD s, wchar_t wc, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (wcrtomb_l(s, wc, ps, uselocale(NULL)));
 }
--- /dev/null	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/wcscasecmp.c	Tue May 20 07:58:52 2014
@@ -0,0 +1,83 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright (c) 1992, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
+
+/*
+ * Compare strings ignoring case difference.
+ *	returns:  s1>s2: >0  s1==s2: 0  s1<s2: <0
+ * All letters are converted to the lowercase and compared.
+ */
+
+#include "lint.h"
+#include <stdlib.h>
+#include <wchar.h>
+#include <locale.h>
+#include "libc.h"
+
+/* Legacy Sun interfaces */
+#pragma weak wscasecmp = wcscasecmp
+#pragma weak wsncasecmp = wcsncasecmp
+
+int
+wcscasecmp_l(const wchar_t *s1, const wchar_t *s2, locale_t loc)
+{
+	if (s1 == s2)
+		return (0);
+
+	while (towlower_l(*s1, loc) == towlower_l(*s2, loc)) {
+		if (*s1 == 0)
+			return (0);
+		s1++;
+		s2++;
+	}
+	return (towlower_l(*s1, loc) - towlower_l(*s2, loc));
+}
+
+int
+wcscasecmp(const wchar_t *s1, const wchar_t *s2)
+{
+	return (wcscasecmp_l(s1, s2, uselocale(NULL)));
+}
+
+int
+wcsncasecmp_l(const wchar_t *s1, const wchar_t *s2, size_t n, locale_t loc)
+{
+	if (s1 == s2)
+		return (0);
+
+	while ((towlower_l(*s1, loc) == towlower_l(*s2, loc)) && n--) {
+		if (*s1 == 0)
+			return (0);
+		s1++;
+		s2++;
+	}
+	return (towlower_l(*s1, loc) - towlower_l(*s2, loc));
+}
+
+int
+wcsncasecmp(const wchar_t *s1, const wchar_t *s2, size_t n)
+{
+	return (wcsncasecmp_l(s1, s2, n, uselocale(NULL)));
+}
--- old/usr/src/lib/libc/port/locale/wcscoll.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/wcscoll.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002 Tim J. Robbins
  * All rights reserved.
@@ -32,17 +33,17 @@
 #include <wchar.h>
 #include <assert.h>
 #include "collate.h"
+#include "localeimpl.h"
 
 int
-wcscoll(const wchar_t *ws1, const wchar_t *ws2)
+wcscoll_l(const wchar_t *ws1, const wchar_t *ws2, locale_t loc)
 {
 	int len1, len2, pri1, pri2, ret;
 	wchar_t *tr1 = NULL, *tr2 = NULL;
 	int direc, pass;
+	const struct lc_collate *lcc = loc->collate;
 
-	collate_info_t *info = _collate_info;
-
-	if (_collate_load_error)
+	if (lcc->lc_is_posix)
 		/*
 		 * Locale has no special collating order or could not be
 		 * loaded, do a fast binary comparison.
@@ -63,18 +64,18 @@
 	 * Note that we do one final extra pass at the end to pick
 	 * up UNDEFINED elements.  There is special handling for them.
 	 */
-	for (pass = 0; pass <= info->directive_count; pass++) {
+	for (pass = 0; pass <= lcc->lc_directive_count; pass++) {
 
-		int32_t *st1 = NULL;
-		int32_t *st2 = NULL;
+		const int32_t *st1 = NULL;
+		const int32_t *st2 = NULL;
 		const wchar_t	*w1 = ws1;
 		const wchar_t	*w2 = ws2;
 
 		/* special pass for UNDEFINED */
-		if (pass == info->directive_count) {
+		if (pass == lcc->lc_directive_count) {
 			direc = DIRECTIVE_FORWARD | DIRECTIVE_UNDEFINED;
 		} else {
-			direc = info->directive[pass];
+			direc = lcc->lc_directive[pass];
 		}
 
 		if (direc & DIRECTIVE_BACKWARD) {
@@ -104,7 +105,8 @@
 		if (direc & DIRECTIVE_POSITION) {
 			while ((*w1 || st1) && (*w2 || st2)) {
 				pri1 = pri2 = 0;
-				_collate_lookup(w1, &len1, &pri1, pass, &st1);
+				_collate_lookup(lcc, w1, &len1, &pri1, pass,
+				    &st1);
 				if (pri1 <= 0) {
 					if (pri1 < 0) {
 						errno = EINVAL;
@@ -112,7 +114,8 @@
 					}
 					pri1 = COLLATE_MAX_PRIORITY;
 				}
-				_collate_lookup(w2, &len2, &pri2, pass, &st2);
+				_collate_lookup(lcc, w2, &len2, &pri2, pass,
+				    &st2);
 				if (pri2 <= 0) {
 					if (pri2 < 0) {
 						errno = EINVAL;
@@ -131,7 +134,7 @@
 			while ((*w1 || st1) && (*w2 || st2)) {
 				pri1 = pri2 = 0;
 				while (*w1) {
-					_collate_lookup(w1, &len1,
+					_collate_lookup(lcc, w1, &len1,
 					    &pri1, pass, &st1);
 					if (pri1 > 0)
 						break;
@@ -142,7 +145,7 @@
 					w1 += len1;
 				}
 				while (*w2) {
-					_collate_lookup(w2, &len2,
+					_collate_lookup(lcc, w2, &len2,
 					    &pri2, pass, &st2);
 					if (pri2 > 0)
 						break;
@@ -185,4 +188,11 @@
 fail:
 	ret = wcscmp(ws1, ws2);
 	goto end;
+}
+
+
+int
+wcscoll(const wchar_t *ws1, const wchar_t *ws2)
+{
+	return (wcscoll_l(ws1, ws2, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wcsnrtombs.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/wcsnrtombs.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -29,24 +30,35 @@
 #include <limits.h>
 #include <stdlib.h>
 #include <string.h>
+#include <locale.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 size_t
-wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
-    size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
+wcsnrtombs_l(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+    size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps, locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__wcsnrtombs(dst, src, nwc, len, ps));
+	return (loc->ctype->lc_wcsnrtombs(dst, src, nwc, len, ps));
 }
 
 size_t
-__wcsnrtombs_std(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+wcsnrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
     size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps)
 {
+	return (wcsnrtombs_l(dst, src, nwc, len, ps, uselocale(NULL)));
+}
+
+size_t
+__wcsnrtombs_std(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+    size_t nwc, size_t len, mbstate_t *_RESTRICT_KYWD ps,
+    wcrtomb_pfn_t pwcrtomb)
+{
 	mbstate_t mbsbak;
 	char buf[MB_LEN_MAX];
 	const wchar_t *s;
@@ -58,7 +70,7 @@
 
 	if (dst == NULL) {
 		while (nwc-- > 0) {
-			if ((nb = __wcrtomb(buf, *s, ps)) == (size_t)-1)
+			if ((nb = pwcrtomb(buf, *s, ps)) == (size_t)-1)
 				/* Invalid character - wcrtomb() sets errno. */
 				return ((size_t)-1);
 			else if (*s == L'\0')
@@ -72,7 +84,7 @@
 	while (len > 0 && nwc-- > 0) {
 		if (len > (size_t)MB_CUR_MAX) {
 			/* Enough space to translate in-place. */
-			if ((nb = __wcrtomb(dst, *s, ps)) == (size_t)-1) {
+			if ((nb = pwcrtomb(dst, *s, ps)) == (size_t)-1) {
 				*src = s;
 				return ((size_t)-1);
 			}
@@ -85,7 +97,7 @@
 			 * character is too long for the buffer.
 			 */
 			mbsbak = *ps;
-			if ((nb = __wcrtomb(buf, *s, ps)) == (size_t)-1) {
+			if ((nb = pwcrtomb(buf, *s, ps)) == (size_t)-1) {
 				*src = s;
 				return ((size_t)-1);
 			}
--- old/usr/src/lib/libc/port/locale/wcsrtombs.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/wcsrtombs.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -30,15 +31,24 @@
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
+#include "localeimpl.h"
+#include "lctype.h"
 #include "mblocal.h"
 
 size_t
-wcsrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
-    size_t len, mbstate_t *_RESTRICT_KYWD ps)
+wcsrtombs_l(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps, locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__wcsnrtombs(dst, src, ULONG_MAX, len, ps));
+	return (loc->ctype->lc_wcsnrtombs(dst, src, ULONG_MAX, len, ps));
+}
+
+size_t
+wcsrtombs(char *_RESTRICT_KYWD dst, const wchar_t **_RESTRICT_KYWD src,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (wcsrtombs_l(dst, src, len, ps, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wcstombs.c	Tue May 20 07:58:52 2014
+++ new/usr/src/lib/libc/port/locale/wcstombs.c	Tue May 20 07:58:52 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -30,9 +31,12 @@
 #include <stdlib.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "localeimpl.h"
+#include "lctype.h"
 
 size_t
-wcstombs(char *_RESTRICT_KYWD s, const wchar_t *_RESTRICT_KYWD pwcs, size_t n)
+wcstombs_l(char *_RESTRICT_KYWD s, const wchar_t *_RESTRICT_KYWD pwcs,
+    size_t n, locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	mbstate_t mbs;
@@ -40,5 +44,11 @@
 
 	mbs = initial;
 	pwcsp = pwcs;
-	return (__wcsnrtombs(s, &pwcsp, ULONG_MAX, n, &mbs));
+	return (loc->ctype->lc_wcsnrtombs(s, &pwcsp, ULONG_MAX, n, &mbs));
+}
+
+size_t
+wcstombs(char *_RESTRICT_KYWD s, const wchar_t *_RESTRICT_KYWD pwcs, size_t n)
+{
+	return (wcstombs_l(s, pwcs, n, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wcswidth.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wcswidth.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -37,10 +38,12 @@
  */
 
 #include "lint.h"
+#include <locale.h>
 #include <wchar.h>
+#include <xlocale.h>
 
 int
-wcswidth(const wchar_t *pwcs, size_t n)
+wcswidth_l(const wchar_t *pwcs, size_t n, locale_t loc)
 {
 	wchar_t wc;
 	int len, l;
@@ -47,9 +50,15 @@
 
 	len = 0;
 	while (n-- > 0 && (wc = *pwcs++) != L'\0') {
-		if ((l = wcwidth(wc)) < 0)
+		if ((l = wcwidth_l(wc, loc)) < 0)
 			return (-1);
 		len += l;
 	}
 	return (len);
+}
+
+int
+wcswidth(const wchar_t *pwcs, size_t n)
+{
+	return (wcswidth_l(pwcs, n, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wcsxfrm.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wcsxfrm.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1995 Alex Tatmanjants <alex@elvisti.kiev.ua>
  *		at Electronni Visti IA, Kiev, Ukraine.
@@ -36,10 +37,11 @@
 #define	WCS_XFRM_OFFSET	1
 
 size_t
-wcsxfrm(wchar_t *_RESTRICT_KYWD dest,
-    const wchar_t *_RESTRICT_KYWD src, size_t len)
+wcsxfrm_l(wchar_t *_RESTRICT_KYWD dest,
+    const wchar_t *_RESTRICT_KYWD src, size_t len, locale_t loc)
 {
 	size_t slen;
+	const struct lc_collate *lcc = loc->collate;
 
 	if (*src == L'\0') {
 		if (len != 0)
@@ -47,8 +49,8 @@
 		return (0);
 	}
 
-	if ((_collate_load_error) ||
-	    ((slen = _collate_wxfrm(src, dest, len)) == (size_t)-1)) {
+	if ((lcc->lc_is_posix) ||
+	    ((slen = _collate_wxfrm(lcc, src, dest, len)) == (size_t)-1)) {
 		goto error;
 	}
 
@@ -70,4 +72,11 @@
 		dest[len - 1] = L'\0';
 	}
 	return (slen);
+}
+
+size_t
+wcsxfrm(wchar_t *_RESTRICT_KYWD dest,
+    const wchar_t *_RESTRICT_KYWD src, size_t len)
+{
+	return (wcsxfrm_l(dest, src, len, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wctob.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wctob.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -29,16 +30,24 @@
 #include <limits.h>
 #include <stdio.h>
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
 
 int
-wctob(wint_t c)
+wctob_l(wint_t c, locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	mbstate_t mbs = initial;
 	char buf[MB_LEN_MAX];
 
-	if (c == WEOF || __wcrtomb(buf, c, &mbs) != 1)
+	if (c == WEOF || wcrtomb_l(buf, c, &mbs, loc) != 1)
 		return (EOF);
 	return ((unsigned char)*buf);
+}
+
+int
+wctob(wint_t c)
+{
+	return (wctob_l(c, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wctomb.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wctomb.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -28,10 +29,12 @@
 #include "lint.h"
 #include <stdlib.h>
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
 
 int
-wctomb(char *s, wchar_t wchar)
+wctomb_l(char *s, wchar_t wchar, locale_t loc)
 {
 	static const mbstate_t initial = { 0 };
 	static mbstate_t mbs;
@@ -42,7 +45,13 @@
 		mbs = initial;
 		return (0);
 	}
-	if ((rval = __wcrtomb(s, wchar, &mbs)) == (size_t)-1)
+	if ((rval = wcrtomb_l(s, wchar, &mbs, loc)) == (size_t)-1)
 		return (-1);
 	return ((int)rval);
+}
+
+int
+wctomb(char *s, wchar_t wchar)
+{
+	return (wctomb_l(s, wchar, uselocale(NULL)));
 }
